package org.jbpm.examples.identity;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import org.jbpm.api.identity.Group;
import org.jbpm.api.identity.User;
import org.jbpm.pvm.internal.identity.spi.IdentitySession;


public class CustomIdentitySession implements IdentitySession {
  
  static HashMap<String, Group> groups = new HashMap<String, Group>();
  static HashMap<String, User> users = new HashMap<String, User>();
  static HashMap<String, List<User>> members = new HashMap<String, List<User>>();
 

  public String createGroup(String groupName, String groupType, String parentGroupId) {
    System.out.println("################## create group  ########################");
    groups.put(groupName, new CustomGroup(groupName, groupName, groupType));
    return groupName;
  }

  public void createMembership(String userId, String groupId, String role) {
    System.out.println("################## create membership  ########################");
    List<User> usersInGroup = members.get(groupId);
    if (usersInGroup == null) {
      usersInGroup = new ArrayList<User>();
      
      members.put(groupId, usersInGroup);
    }
    usersInGroup.add(users.get(userId));
  }

  public String createUser(String userId, String givenName, String familyName, String businessEmail) {
    System.out.println("################## create user  ########################");
    users.put(userId, new CustomUser(userId, familyName, givenName, businessEmail));
    return userId;
  }

  public void deleteGroup(String groupId) {
    System.out.println("################## delete user  ########################");
    groups.remove(groupId);
  }

  public void deleteMembership(String userId, String groupId, String role) {
    
    System.out.println("################## delete membership  ########################");
    List<User> usersInGroup = members.get(groupId);
    if (usersInGroup != null) {
      
      for (User u : usersInGroup) {
        if (u.getId().equals(userId)) {
          usersInGroup.remove(userId);
          break;
        }
      }
      
    }
  }

  public void deleteUser(String userId) {
    System.out.println("################## delete user  ########################");
    users.remove(userId);
  }

  public Group findGroupById(String groupId) {
    
    System.out.println("################## find group by id  ########################");
    return groups.get(groupId);
  }

  public List<Group> findGroupsByUser(String userId) {
    System.out.println("################## find groups by user id  ########################");
    List<Group> userGroups = new ArrayList<Group>();
    
    Iterator<String> it = members.keySet().iterator();
    
    while (it.hasNext()) {
      String groupId = (String) it.next();
      List<User> users = members.get(groupId);
      
      for (User u : users) {
        if (u.getId().equals(userId)) {
          
          userGroups.add(groups.get(groupId));
          break;
          }
      }
    }
    
    
    return userGroups;
  }

  public List<Group> findGroupsByUserAndGroupType(String userId, String groupType) {
    System.out.println("################## find group by user id and group type  ########################");
    return findGroupsByUser(userId);
  }

  public User findUserById(String userId) {
    System.out.println("##################  find user by id ########################");
    return users.get(userId);
  }

  public List<User> findUsers() {
    System.out.println("##################  find users ########################");
    return new ArrayList<User>(users.values());
  }

  public List<User> findUsersByGroup(String groupId) {
    System.out.println("################## find users by group  ########################");
    return members.get(groupId);
  }

  public List<User> findUsersById(String... userIds) {
    System.out.println("################## find users by id  ########################");
    return null;
  }

}
